/*
 * This file is part of ascad.
 *
 * Ascad is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ascad is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ascad; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
 
/* Copyright (C) 2005 Andrei Krger */

#include <string.h>

#include "ascad.h"
#include "ocad.h"

void foo() {}

#define BUF_SIZE 0x1000
#define GET_WORD(x) (*(word*)(x))

void ocd_update_template(char *fn, char *template, rect page, double resolution) {
  FILE *ocd;
  char buf[BUF_SIZE], str[256];
  TFileHeader *header;
  TStp *setup;
  dword offset, size;
  char *c;

  if ((ocd = fopen(fn, "r+")) == NULL)
    xperror(fn);

  if (fread(buf, 1, 48, ocd) < 48)
    xerror("%s: Not ocad-file", fn);

  header = (TFileHeader*)buf;
  if (header->OCADMark != 0x0cad) 
    xerror("%s: Not ocad-file", fn);
  if (header->Version != 7 || header->SectionMark != 7)
    xerror("%s: Only ocad 7 supported");

  offset = header->SetupPos;
  size = header->SetupSize;
  if (fseek(ocd, offset, SEEK_SET))
    xperror(fn);
  if (fread(buf, 1, size, ocd) != size)
    xperror(fn);
  setup = (TStp*)buf;

  /* TemplateFileName */
  strcpy(str, dospath);
  c = str + strlen(str);
  if (c > str && (*(c-1) != '/' && *(c-1) != '\\')) strcat(c, "\\");
  strcat(str, template);
  for(c=str; *c; c++) if (*c == '/') *c = '\\';
  
  setup->TemplateFileName[0] = strlen(str);
  strncpy(setup->TemplateFileName+1, str, setup->TemplateFileName[0]);

  /* TempOffset 0.01mm */
  setup->TempOffset.x = (long)((page.x2 + page.x1) * 2540 / 72 / 2) <<8;
  setup->TempOffset.y = (long)((page.y2 + page.y1) * 2540 / 72 / 2 ) <<8;

  /* rest */
  setup->TemplateEnabled = 1;
  setup->TempResol = resolution;
  setup->rTempAng = 0.0; /* ocad: double */

  if (fseek(ocd, offset, SEEK_SET))
    xperror(fn);
  if (fwrite(buf, 1, size, ocd) != size)
    xperror(fn);
  
  fclose(ocd);
}

